<?
/**
	A clone of 'WbComboBox'
**/
final class WbListBox extends WbControl{
	private $options;
	
	public Function __construct($parent, $posx=false, $posy=false, $width=120, $height=80, $options=false, $id=false, $style=false, $lparam=false){
		parent::__construct($parent, ListBox, '', $posx, $posy, $width, $height, $id, $style, $lparam);
		$this->addOption($options);
	}
	public Function __get($var){
		switch($var){
			case "selectedIndex": return $this->getSelectedIndex();
			case "selectedValue": return $this->getSelectedValue();
		}
		parent::__get($var);
	}
	public Function __set($var, $val){
		switch($var){
			case "selectedIndex": return $this->setSelectedIndex($val);
		}
		parent::__set($var, $val);
	}
	
	public Function addOption($value, $inner=false){
		if(is_array($value))
			foreach($value as $op)
				if(is_array($op))
					$toadd[] = Array($op[0], $op[1]);
				else
					$toadd[] = Array($op, $op);
		else
			$toadd[] = Array($value, $inner?$inner:$value);
		
		foreach($toadd as $ta)
			$this->options[] = $ta;

		$this->refreshOptions();
	}
	public Function deleteOption($index, $length=1){
		if(!isset($this->options[$index]))
			return false;
		array_splice($this->options, $index, $length);
		$this->refreshOptions();
	}
	public Function clearOptions(){
		array_splice($this->options, 0);
		$this->refreshOptions();
	}
	public Function refreshOptions(){
		$output = "";
		foreach($this->options as $op)
			$output .= "\n" . $op[1];
		parent::setText($output);
	}
	
	public Function getSelectedIndex(){
		return $this->getValue();
	}
	public Function setSelectedIndex($index){
		return $this->setValue($index);
	}
	public Function getSelectedValue(){
		$si = $this->getSelectedIndex();
		return ($si<0)?$si:$this->options[$si][0];
	}
	
	public Function setText($value){
		return false;
	}
}