<?
abstract class WbWindow extends WbObject{
	public Function __construct($type, $parent, $caption=false, $xpos=false, $ypos=false, $width=false, $height=false, $style=false, $lparam=false){
		if($width)  // ($type, $parent, $caption, $xpos, $ypos, $width, $height, $style, $lparam)
			$this->handler = wb_create_window($parent?$parent->handler:false, $type, $caption, $xpos, $ypos, $width, $height, $style, $lparam);
		else // ($type, $parent, $caption, $width, $height)
			$this->handler = wb_create_window($parent?$parent->handler:false, $type, $caption, WBC_CENTER, WBC_CENTER, $xpos, $ypos);
	}
	public Function __destroy(){
		$this->destroy();
	}

	public Function setHandler($handler){
		wb_set_handler($this->handler, $handler);
	}
	public Function destroy(){
		wb_destroy_window($this->handler);
	}
	public Function getControl($id=false){
		return wb_get_control($this->handler, $id);
	}
	public Function messageBox($message, $title=false, $style=WBC_OK){
		/**
			The following styles are supported:
				WBC_INFO, WBC_OK, WBC_OKCANCEL, WBC_QUESTION,
				WBC_STOP, WBC_WARNING, WBC_YESNO, WBC_YESNOCANCEL
				
			The following values may be returned:
				IDABORT, IDCANCEL, IDIGNORE, IDNO, IDOK, IDRETRY, IDYES
		**/
		return wb_message_box($this->handler, $message, $title, $style);
	}
	public Function sysDlgColor($title=false, $color=false){
		return wb_sys_dlg_color($this->handler, $title, $color);
	}
	public Function sysDlgOpen($title=false, $filter=false, $path=false, $filename=false){
		return wb_sys_dlg_open($this->handler, $title, $filter, $path, $filename);
	}
	public Function sysDlgPath($title=false, $path=false){
		return wb_sys_dlg_path($this->handler, $title, $path);
	}
	public Function sysDlgSave($title=false, $filter=false, $path=false, $filename=false){
		return wb_sys_dlg_path($this->handler, $title, $filter, $path, $filename);
	}
	
	/**
		Additional functions, to make coding easier
	**/
}

final class WbAppWindow extends WbWindow{
	public Function __construct($caption=false, $posx=false, $posy=false, $width=false, $height=false, $style=false, $lparam=false){
		parent::__construct(AppWindow, false, $caption, $posx, $posy, $width, $height, $style, $lparam);
	}
}
final class WbPopupWindow extends WbWindow{
	public Function __construct($caption=false, $posx=false, $posy=false, $width=false, $height=false, $style=false, $lparam=false){
		parent::__construct(PopupWindow, false, $caption, $posx, $posy, $width, $height, $style, $lparam);
	}
}
final class WbResizableWindow extends WbWindow{
	public Function __construct($caption=false, $posx=false, $posy=false, $width=false, $height=false, $style=false, $lparam=false){
		parent::__construct(ResizableWindow, false, $caption, $posx, $posy, $width, $height, $style, $lparam);
	}
}
final class WbModalDialog extends WbWindow{
	public Function __construct(WbWindow $parent, $caption=false, $posx=false, $posy=false, $width=false, $height=false, $style=false, $lparam=false){
		parent::__construct(ModalDialog, $parent, $caption, $posx, $posy, $width, $height, $style, $lparam);
	}
}
final class WbToolDialog extends WbWindow{
	public Function __construct(WbWindow $parent, $caption=false, $posx=false, $posy=false, $width=false, $height=false, $style=false, $lparam=false){
		parent::__construct(ToolDialog, $parent, $caption, $posx, $posy, $width, $height, $style, $lparam);
	}
}
final class WbModelessDialog extends WbWindow{
	public Function __construct(WbWindow $parent, $caption=false, $posx=false, $posy=false, $width=false, $height=false, $style=false, $lparam=false){
		parent::__construct(ModelessDialog, $parent, $caption, $posx, $posy, $width, $height, $style, $lparam);
	}
}
